#include <stdio.h>
#include "mpi.h"

int main(int argc, char **argv)
{
	int rank, size;
	
	// initialize MPI environment, read argument from "mpirun" command (number of processes, machine file)
    	MPI_Init(&argc,&argv);

	// get the number of processes and send the value to "size"
    	MPI_Comm_size(MPI_COMM_WORLD,&size);

	// for each process, get the value of rank (process identifier, from 0 to N-1)
    	MPI_Comm_rank(MPI_COMM_WORLD,&rank);

	// for each process, print the value of rank and size, running in parallel 
    	printf( "Hello world from process %d of %d\n",rank,size);

	// terminate the MPI environment, all the processes should call this routine before exit
    	MPI_Finalize();

    	return 0;
}
